@echo off

rem  openisis - an open implementation of the ISIS database
rem  Version 0.8.x (microversion see file Version)
rem  Copyright (C) 2001-2002 by Erik Grziwotz, erik@openisis.org
rem
rem  This library is free software; you can redistribute it and/or
rem  modify it under the terms of the GNU Lesser General Public
rem  License as published by the Free Software Foundation; either
rem  version 2.1 of the License, or (at your option) any later version.
rem
rem  This library is distributed in the hope that it will be useful,
rem  but WITHOUT ANY WARRANTY; without even the implied warranty of
rem  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
rem  Lesser General Public License for more details.
rem
rem  You should have received a copy of the GNU Lesser General Public
rem  License along with this library; if not, write to the Free Software
rem  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
rem
rem  This software is dedicated to the memory of Eckart Dietrich.
rem
rem  This software is inspired by (but contains no code of) the iAPI
rem  Copyright (C) 2000 by Robert Janusz, rj@jezuici.krakow.pl.
rem  See iAPI.txt for what it contains.
rem
rem
rem  $Id: jtest.bat,v 1.1 2002/08/28 14:47:13 erikisis Exp $
rem  Testscript for openisis java classes on win32 platforms
rem

set CLASSPATH=.

if not exist testout.txt goto bug
del testout.txt

:bug

java org.openisis.Test -db db/cds/cds -encoding Cp850 -row 42 >> testout.txt
java org.openisis.Test -db db/cds/cds -encoding Cp850 -search development >> testout.txt
java org.openisis.Test -db db/cds/cds -encoding Cp850 -terms "" >> testout.txt
java org.openisis.Test -db db/cds/cds -encoding Cp850 -mpu -row 130 >> testout.txt
java org.openisis.Test -db db/cds/cds -encoding Cp850 -mhl -hta -row 130 >> testout.txt
java org.openisis.Test -db db/cds/cds -encoding Cp850 -m1 -row 130 >> testout.txt

fc testout.txt jtest.txt


