/*
	openisis - an open implementation of the ISIS database
	Version 0.8.x (microversion see file Version)
	Copyright (C) 2001-2002 by Erik Grziwotz, erik@openisis.org

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	This software is dedicated to the memory of Eckart Dietrich.

	This software is inspired by (but contains no code of) the iAPI
	Copyright (C) 2000 by Robert Janusz, rj@jezuici.krakow.pl.
	See iAPI.txt for what it contains.
EOH */
#ifndef LFDT_H

/*
	$Id: lfdt.h,v 1.5 2003/03/16 18:58:49 mawag Exp $
	FDT support
*/

#include "loi.h"

extern int fdtFromFile (char *path, Fd **fds, Rec **rec);

extern Rec *fd2rec (Session ses, Fd *fd);

/* append fdt to rec */
extern Rec *fdt2rec (Session ses, Rec *rec, Fdt *fdt, int tag);

extern Fd *rec2fd (Session ses, Rec *rec, Fd *buf);

/* extract fdt from rec */
extern Fdt *rec2fdt (Session ses, Rec *rec, int idnum, int idfd, int *pos);

#define LFDT_H
#endif /* LFDT_H */
