/*
	openisis - an open implementation of the ISIS database
	Version 0.8.x (microversion see file Version)
	Copyright (C) 2001-2002 by Erik Grziwotz, erik@openisis.org

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	This software is dedicated to the memory of Eckart Dietrich.

	This software is inspired by (but contains no code of) the iAPI
	Copyright (C) 2000 by Robert Janusz, rj@jezuici.krakow.pl.
	See iAPI.txt for what it contains.
EOH */

package org.openisis;

import java.io.IOException;
import java.io.FileNotFoundException;
import java.util.Iterator;


/**
	This class is the pure java implementation of class Db.
	Unfortunately, it's still empty :(
<p>
	$Id: PureDb.java,v 1.3 2003/03/05 19:52:29 istr Exp $
	@version $Revision: 1.3 $
	@author  $Author: istr $
*/
public class PureDb extends Db {

	public PureDb ( String enc, String dbname, String[] args )
		throws IOException
	{
		super( enc );
		throw new UnsupportedOperationException( "sorry, not implemented" );
	}

	public Rec readRow ( int rowid ) {
		throw new UnsupportedOperationException( "sorry, not implemented" );
	}	// readrow

	public short writeRow ( Rec row ) {
		throw new UnsupportedOperationException( "sorry, not implemented" );
	} // writerow

	public short writeXRow ( Rec row, Rec idx ) {
		throw new UnsupportedOperationException( "sorry, not implemented" );
	} // writerow

	public Rec scanRow ( int rowid, int tag, String txt ) {
		throw new UnsupportedOperationException( "sorry, not implemented" );
	}	// scanrow

	public int[] search ( String key, int mode ) {
		throw new UnsupportedOperationException( "sorry, not implemented" );
	}	// search

	public Iterator terms ( String prefix ) {
		throw new UnsupportedOperationException( "sorry, not implemented" );
	}

}	// PureDb
